<template>
    <TableHeader area datePicker nextFlag theCurrentTime showTimeAll ref="TableHeaderRef" showExport showCustomColumn>
        <template #select>
            <el-form-item label="监督类型">
                <el-select v-model="tableStore.table.params.supvType" clearable placeholder="请选择监督类型" filterable>
                    <el-option
                        v-for="item in supvTypeOptionList"
                        :key="item.id"
                        :label="item.name"
                        :value="item.id"
                    ></el-option>
                </el-select>
            </el-form-item>
            <el-form-item label="流程状态">
                <el-select v-model="tableStore.table.params.status" clearable placeholder="请选择流程状态" filterable>
                    <el-option
                        v-for="item in statusSelect"
                        :key="item.id"
                        :label="item.name"
                        :value="item.id"
                    ></el-option>
                </el-select>
            </el-form-item>
        </template>
        <template #operation>
            <el-button icon="el-icon-Plus" type="primary" @click="add">新增计划</el-button>
            <el-button icon="el-icon-Delete" type="primary" @click="deleteEven">删除</el-button>
            <!-- <el-button icon="el-icon-Download" type="primary" @click="exportExcelTemplate" :loading="loading">模板下载</el-button>
            <el-button icon="el-icon-Upload" type="primary" @click="importUserData">批量导入</el-button> -->
        </template>
    </TableHeader>
    <Table ref="tableRef" :checkbox-config="checkboxConfig" />
    <!-- 新增 -->
    <planAdd ref="planAddRef" @onsubmit="tableStore.index()" :openType="openType" />
            <!-- 批量导入 -->
            <sensitive-user-popup ref="sensitiveUserPopup" />
</template>
<script setup lang="ts">
import { useAdminInfo } from '@/stores/adminInfo'
//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
import { ref, onMounted, provide, watch, nextTick } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import { cancel, getById } from '@/api/process-boot/generalTest'
import planAdd from './planAdd.vue'
import { useRouter } from 'vue-router'
import SensitiveUserPopup from './sensitiveUserPopup.vue'
import { queryPlan, removeSurvey } from '@/api/process-boot/generalTest'
import { getUserByRoleType } from '@/api/user-boot/user'
import { useDictData } from '@/stores/dictData'
import { deleteSurveyPlan } from '@/api/supervision-boot/delete/index'
import { getUserReportById } from '@/api/supervision-boot/interfere'
import { downloadPlanTemplate } from '@/api/supervision-boot/userReport/form'
const loading = ref(false)
const dictData = useDictData()
const supvTypeOptionList = dictData.getBasicData('supv_type')
const statusSelect = dictData.statusSelect()
const { push, options, currentRoute } = useRouter()
const dialogVisible = ref(false)
const tableRef = ref()
const planAddRef = ref()
const TableHeaderRef = ref()
const auditList: any = ref([])
const auditUser = ref('')
const flag = ref(false)
const openType = ref('create')
const tableStore = new TableStore({
    url: '/supervision-boot/surveyPlan/surveyPlanPage',
    publicHeight: 65,
    method: 'POST',
    filename: '技术监督计划管理',
    column: [
        {
            width: '60',
            type: 'checkbox'
        },
        {
            title: '序号',
            width: 80,
            formatter: (row: any) => {
                return (tableStore.table.params.pageNum - 1) * tableStore.table.params.pageSize + row.rowIndex + 1
            }
        },
        {
            field: 'planName',
            title: '计划名称',
            minWidth: 130
        },
        {
            field: 'supvType',
            title: '监督类型',
            minWidth: 130,
            formatter: (row: any) => {
                return supvTypeOptionList.filter(item => item.id === row.cellValue)[0]?.name
            }
        },
        {
            field: 'supvObjectName',
            minWidth: 130,
            title: '监督对象名称'
        },
        {
            field: 'deptName',
            minWidth: 130,
            title: '负责单位'
        },
        {
            field: 'substation',
            title: '变电站',
            minWidth: 110,
            formatter: (row: any) => {
                return row.cellValue
            }
        },

        { field: 'planStartTime', minWidth: 130, title: '计划开始时间' },
        { field: 'planEndTime', minWidth: 130, title: '计划结束时间' },
        {
            field: 'status',
            title: '流程状态',
            render: 'tag',
            minWidth: 80,
            custom: {
                0: 'warning',
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning'
            },
            replaceValue: {
                0: '待提交审批',
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消'
            }
        },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 80,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },
        {
             title: '操作',fixed: 'right',
            minWidth: '180',
           
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    disabled: row => {
                        return !row.processInstanceId
                    },
                    click: row => {
                        flag.value = true
                        handleAudit(row.processInstanceId, row.historyInstanceId)
                    }
                },
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    showDisabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 0)
                    },
                    disabled: row => {
                        return !(row.status == 0)
                    },
                    click: row => {
                        planAddRef.value.open('编辑', row.id, false)
                    }
                },
                {
                    name: 'edit',
                    title: '重新发起',
                    type: 'warning',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 3 || row.status == 4)
                    },
                    click: row => {
                        // deviceQuitPopup.value.open('重新发起退运', row)
                        planAddRef.value.open('重新发起计划', row.id, false)
                    }
                },
                {
                    name: 'cancel',
                    title: '取消',
                    type: 'danger',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || row.status != 1
                    },
                    click: row => {
                        cancelLeave(row)
                    }
                }
            ]
        }
    ],
    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        tableStore.table.params.currentPage = tableStore.table.params.pageNum
    },
    exportProcessingData: () => {
        tableStore.table.allData = tableStore.table.allData.filter(item => {
            item.status =
                item.status == 0
                    ? '待提交审批'
                    : item.status == 1
                    ? '审批中'
                    : item.status == 2
                    ? '审批通过'
                    : item.status == 3
                    ? '审批不通过'
                    : '已取消'
            return item
        })
    }
})
const sensitiveUserPopup = ref()
tableStore.table.params.status = ''
tableStore.table.params.supvType = ''
provide('tableStore', tableStore)
// 新增计划
const add = () => {
    // title.value = '普测计划新增'
    planAddRef.value.open('计划新增')
}
// 禁止点击
const checkboxConfig = reactive({
    checkMethod: ({ row }) => {
        return adminInfo.roleCode.includes('delete_info')
            ? true
            : row.createBy == adminInfo.$state.id && row.status == 0
    }
})
const deleteEven = () => {
    if (tableStore.table.selection.length == 0) {
        ElMessage({
            type: 'warning',
            message: '请选择要删除的数据'
        })
    } else {
        ElMessageBox.confirm('此操作将永久删除, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
        }).then(() => {
            deleteSurveyPlan(tableStore.table.selection.map(item => item.id)).then(res => {
                ElMessage({
                    type: 'success',
                    message: '删除成功!'
                })
                tableStore.index()
            })
        })
    }
}
const exportFn = () => {
    let form = JSON.parse(JSON.stringify(tableStore.table.params))
    form.pageNum = 1
    form.pageSize = tableStore.table.total
    queryPlan(form).then(res => {
        tableRef.value.getRef().exportData({
            filename: '计划', // 文件名字
            sheetName: 'Sheet1',
            type: 'xlsx', //导出文件类型 xlsx 和 csv
            useStyle: true,
            data: res.data.records, // 数据源 // 过滤那个字段导出
            columnFilterMethod: function (column: any) {
                return !(column.$columnIndex === 0)
            }
        })
    })
}
//导出模板
const exportExcelTemplate = async() => {
    loading.value = true
   await downloadPlanTemplate().then((res: any) => {
        let blob = new Blob([res], {
            type: 'application/vnd.ms-excel'
        })
        const url = window.URL.createObjectURL(blob)
        const link = document.createElement('a')
        link.href = url
        link.download = '技术监督计划管理模板'
        document.body.appendChild(link)
        link.click()
        link.remove()
    })
    await setTimeout(() => {
        loading.value = false
    },0)
}
/**取消流程操作*/
const cancelLeave = async (row: any) => {
    // 二次确认
    const { value } = await ElMessageBox.prompt('请输入取消原因', '取消流程', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputType: 'textarea',
        inputPattern: /^[\s\S]*.*\S[\s\S]*$/, // 判断非空，且非空格
        inputErrorMessage: '取消原因不能为空'
    })
    // 发起取消
    let data = {
        id: row.id,
        processInstanceId: row.processInstanceId,
        reason: value
    }
    await cancel(data)
    ElMessage.success('取消成功')
    // 加载数据
    tableStore.index()
}

const handleClose = () => {
    dialogVisible.value = false
    auditUser.value = ''
}
//批量导入用户数据
const importUserData = () => {
    sensitiveUserPopup.value.open('技术监督计划管理')
}
/** 处理审批按钮 */
const handleAudit = (instanceId: string, historyInstanceId: string) => {
    push({
        name: 'BpmProcessInstanceDetail',
        state: {
            id: instanceId,
            historyInstanceId
        }
    })
}
// 取消

onMounted(() => {
    tableStore.index()
    getUserByRoleType(3).then(res => {
        auditList.value = res.data
    })
})
watch(
    () => currentRoute.value.path,
    () => {
        if (flag.value && options.history.state.forward?.split('/')[1] == 'bpm') {
            tableStore.index()
            flag.value = false
        }
    },
    {
        deep: true
    }
)

const props = defineProps({ id: { type: String, default: 'null' } })
watch(
    () => props.id,
    async (newValue, oldValue) => {
        if (newValue === 'null') return // 直接返回，避免后续逻辑执行
        const fullId = newValue.split('@')[0]
        let nowTime = Date.now()
        const routeTime = Number(newValue.split('@')[1])
        if (isNaN(routeTime) || nowTime - routeTime > import.meta.env.VITE_ROUTE_TIME_OUT) return // 路由时间超过500ms，则不执行
        nextTick(() => {
            planAddRef.value.open('重新发起计划', fullId, false)
        })
    },
    { immediate: true }
)
</script>

<style scoped lang="scss"></style>
